<template>
  <div id="app" :class="classes">
    <skm-nav @check-branch-click="openBranchSelectorPopup" />
    <breadcrumb v-if="hasBreadcrumb" />
    <router-view></router-view>
    <login-panel ref="login" />
    <skm-footer />
    <nav-menu />
    <account-menu />
    <!-- <login-message-panel /> -->

    <popup-full v-show="showBranchSelectorPopup">
      <template slot="custom">
        <branch-selector
          class="branch-selector-popup"
          ref="deliverSelector"
          :selection="select"
          :show-close-button="true"
          :groupId="groupId"
          @close-click="closeBranchSelectorPopup"
          @check-scope="checkMatchScope"
        >
          <template slot="otherService">
            <div class="row tabs">
              <template v-for="(tab, key) in tabs">
                <div v-if="key !== 'delivery'" class="col col-4" :key="key">
                  <router-link
                    class="d-block tab tab--btn"
                    :class="`tab--${key}`"
                    :to="''"
                  >
                    <span>
                      <img
                        :src="`/static/images/icons/${key}-color.png`"
                        alt=""
                      />
                      <span>{{ tab }}</span>
                    </span>
                  </router-link>
                </div>
              </template>
            </div>
          </template>
        </branch-selector>
      </template>
    </popup-full>
  </div>
</template>

<script>
import SkmNav from "@/components/Nav";
import SkmFooter from "@/components/Footer";
import { mapGetters, mapState, mapActions, mapMutations } from "vuex";
import Breadcrumb from "@/components/Breadcrumb";
import LoginPanel from "@/components/LoginPanel";
import NavMenu from "@/components/NavMenu";
import AccountMenu from "@/components/AccountMenu";
// import LoginMessagePanel from "@/components/LoginMessagePanel";
import * as Api from "@/api";
import i18n from "./i18n";
import { setInterval, clearInterval, setTimeout } from "timers";
import location from "./store/location";
import BranchSelector from "@/components/BranchSelector";
import PopupFull from "@/components/PopupFull";

export default {
  name: "app",
  components: {
    SkmNav,
    SkmFooter,
    Breadcrumb,
    LoginPanel,
    NavMenu,
    AccountMenu,
    // LoginMessagePanel,
    PopupFull,
    BranchSelector
  },

  data() {
    return {
      waitingStatusResponse: false,
      routerReady: false,
      loginCheck: false,
      tabs: this.$t("restaurant.tab")
    };
  },

  watch: {
    $route() {
      this.routerReady = true;
      if (this.loginCheck) {
        this.showLoginDialog();
      }
    },

    account(newVal, oldVal) {
      if (!oldVal && newVal) {
        this.waitingStatusResponse = true;
        this.checkStatus = setInterval(() => {
          if (this.waitingStatusResponse) {
            return;
          }
          Api.Accounts.status().then(({ login }) => {
            this.waitingStatusResponse = false;
            if (!login) {
              clearInterval(this.checkStatus);
              alert(this.$t("errorCodes.skm-N1"));
              Api.Accounts.logout()
                .catch(() => {})
                .then(() => window.location.reload());
            }
          });
        }, 10000);
      }
      if (oldVal && !newVal) {
        clearInterval(this.checkStatus);
      }
    }
  },

  computed: {
    ...mapState(["hide"]),
    ...mapGetters("theme", ["themeClasses"]),
    ...mapState("account", ["inLoginProcess", "account"]),
    ...mapState("branch", ["showBranchSelectorPopup", "select"]),
    ...mapGetters({
      branchOptions: "branch/branchOptions",
      cityOptions: "branch/cityOptions",
      areaOptions: "branch/areaOptions"
    }),

    groupId() {
      return this.$route.params.groupId;
    },

    companyId() {
      return this.$route.params.companyId;
    },

    fromApp() {
      return this.account && this.account.fromApp;
    },

    hasBreadcrumb() {
      const routes = ["landing", "Group", "GroupPreorder", "GroupMap"];
      return !~routes.indexOf(this.$route.name) && !this.fromApp;
    },

    classes() {
      return Object.assign({}, this.themeClasses, {
        hide: this.hide,
        login: this.inLoginProcess
      });
    }
  },

  methods: {
    ...mapActions(["show"]),
    ...mapActions("account", [
      // "showLoginMessage",
      "startLogin"
    ]),
    ...mapActions("branch", [
      "openBranchSelectorPopup",
      "closeBranchSelectorPopup",
      "checkMatchScope"
    ]),

    showLoginDialog() {
      if (this.routerReady) {
        if (
          !this.account &&
          this.$route.query &&
          this.$route.query.login === "true"
        ) {
          this.startLogin();
        }
      } else {
        this.loginCheck = true;
      }
    }
  },

  mounted() {
    // I don't fucking know why $route.query is always empty here
    this.$store.dispatch("account/fetchAccount").then(() => {
      if (this.$route.query && this.$route.query.treatment === "true") {
        const query = Object.assign({}, this.$route.query);
        delete query.treatment;
        // this.showLoginMessage();
        this.$router.replace({ query });
      }
      this.showLoginDialog();
    });

    this.$nextTick(() => {
      const route = this.$route;
      if (!(route.name === "RestaurantPreorder" && route.query.itemid)) {
        this.show();
      }

      window.addEventListener("message", event => {
        if (event.origin === Api.endpoint) {
          if (event.data.type === "login-succeeded") {
            this.$store.dispatch("account/fetchAccount").then(() => {
              this.$store.dispatch("account/finishLogin");
            });
            const redirectPath =
              event.data.state &&
              event.data.state.app &&
              event.data.state.app.redirect;
            if (redirectPath) {
              this.$router.push(redirectPath);
              return;
            }

            const crossSiteRedirect =
              this.$route.query &&
              this.$route.query.login === "true" &&
              this.$route.query.login_redirect_url;
            if (crossSiteRedirect) {
              window.location.href = crossSiteRedirect;
            }
          }
          if (event.data.type === "login-failed") {
            this.$store.dispatch("account/finishLogin");
            alert(i18n.t(`errorCodes.${event.data.error}`));
          }
        }
      });
    });
  }
};
</script>

<style lang="scss">
@import "assets/stylesheets/application";

#app.hide {
  display: none;
}

#app.theme-vip-member {
  background: $color-gold-100;
}

#app.login {
  height: 100vh;
  overflow: hidden;
}
</style>

<style lang="scss" scoped>
.branch-selector-dialog {
  @include media-breakpoint-up(md) {
    margin-top: -40%;
  }

  &::v-deep {
    height: 100%;
    @include media-breakpoint-up(md) {
      height: auto;
    }
    .branch-selector-box {
      top: 0;
      left: 0;
      height: 100%;
      background-color: $white;
      @include media-breakpoint-up(md) {
        height: auto;
      }
    }
    .result-box {
      display: block;
      background-color: $white;
      @include media-breakpoint-up(md) {
        display: flex;
        left: 50%;
      }
    }
    .result-content--noResult {
      padding: 0 4%;
    }
  }
}
</style>
